//////////////////////////////////////////////////////////////////////////////////////////
//   	Woltomierz czterokanalowy  ccsC COMPILER 13.08.02								//
//////////////////////////////////////////////////////////////////////////////////////////
#include <16F872.h>
#include <f872.h>
//#fuses rc ,NOWDT,NOPROTECT,NOBROWNOUT,NOPUT
// 			DEBUG     WRT CPD LVP BODEN CP1 CP0 PWRTE WDTE FOSC1 FOSC0
//  13  12   11   10   9   8   7    6    5   4    3     2   1      0
#rom 0x2007={0b00100100111011}					//konfiguracja bezpiecznikow

#use delay(clock=4000000)
#include<lcd_mo.h>

#define Timer1_set   0xffff-12500		  		//100ms=100000*1us=8*12500 ustawienia timera1
#define UP 1
#define OK 2
#define DOWN 3
#define esc 4
int16 analog;
int16 anal[5];									//tu przechowywana jest wartosc napiecia
int16 ana;

byte temp;
byte key;

byte dig_i,digit[5];
#define dig0 digit[0]
#define dig1 digit[1]
#define dig2 digit[2]
#define dig3 digit[3]
#define dig4 digit[4]

byte alarm[5];
int16 uhigh[5];
int16 ulow[5];
get_key();										//obsluga klawiatury
menu();											//obsluga menu
lcd_analog(int16 analog_wejscie);				//wyswietla liczbe z przecinkiem



//***************************************************************************//
//  zamienia wejsciowa liczbe binarna int16, na dziesietna i umieszcza		 //
//  kolejne cyfry w buforze, cyfry dostepne sa jako dig0,dig1 ...			 //
//  ulatwia to zarzadzanie cyframi , np rozdzielenie przecinkiem			 //
//***************************************************************************//
void dec_putc(byte w)
{digit[dig_i]=w;
	dig_i--;}
//--------------------------------------------------------------
get_dig(int16 zz)
{dig_i=4;
printf(dec_putc,"%05lu",zz);}
//***************************************************************************//



//***************************************************************************************//
//	Procedura odczytuje napiecie z podanego wejcia analogowego i zwraca watosc			 //
//	w woltach																			 //
//***************************************************************************************//
Get_adc(byte w)
{
	byte i;
	delay_us(500);
	i=w<<3;							//przesuwa w <<3 i kopiuje w do i
	i&=0b00111000;					//zeruje wszystkie bity oprocz, wyboru kanalu
	i|=0b10000001;					//przetwazania,ustawia czestotliwosc przetwornika na
	adcon0=i;						//Fosc/32 i ustawia stan aktywny przetwornika
	delay_us(100);
	bit_set(adcon0,go);				//start konwersji
	while(bit_test(adcon0,go));		//czekaj na koniec konwersji
	analog=make16(adresh,adresl);	//polacza dwa rejestry wyniku w calosc
	analog*=0.537;					//zamiana na napiecie w formacie xx.xV

	}
//******************************KONIEC PRZETWARZANIA ADC**********************************//

//////////////////////////////////////////////////////////////////////////////////////////
// 								GWNA PTLA PROGRAMU									//
//////////////////////////////////////////////////////////////////////////////////////////
main()
{
	byte licz,lcd_time=0;
	portb=0;
	trisb=0x0f;
	temp=4;
	port_b_pullups(true);
	output_low(pin_c2);
	lcd_init();
	lcd_znaki();
	lcd_init();
	lcd_putc('\r');
    adcon1=0b10000001;						//a0,a1,a2,a5->analog, a3->Vref
	set_timer1(timer1_set);                 // sets timer to interrupt in 100ms
	setup_timer_1(T1_INTERNAL|T1_DIV_BY_8); // setup interrupts
	enable_interrupts(INT_TIMER1);
	enable_interrupts(GLOBAL);
    set_timer0(255);
	for(licz=0;licz<5;licz++)				//ustawia wartosci poczatkowe napiec max i min
		{uhigh[licz]=500;					//tak aby w zadnym przypadku nie powodowaly
		ulow[licz]=0;}						//alarmu


while(1)
	{
//------sprawdza stan klawiatury jesli nacisniety klawisz to skok do obslugi menu)()
		get_key();							//sprawdz klawiature
		if(key>0)
			{menu();						//jesli nacisniety klawisz to idz do obslugi menu

		 	 lcd_time=0;
			 lcd_putc('\q');
		 	 lcd_putc('\r');}				//wylacza kursor

//--------------------------------------------------------------------------
//odczytuje warosci wszystkich napiec i zapisuje je odpowiednio w komorkach
//anal[0]-anal[3]
	for(licz=0;licz<=3;licz++)
		{if(licz==3) licz=4;
			get_adc(licz);
		if(licz==4) licz=3;
		anal[licz]=analog;
//----------------------------------------------------------------------
//sprawdzenie i porownanie napiec mierzonych do ustawionych komparatora
//jesli umin=umax=u zmierzone to alarm wystepuje tylko dla tego napiecia
//w zaleznosci w na ktorym czujniku, do odpowiedniej komorki alarm[n],n=1-4,jest
//wpisywana odpowiednia liczba od 1-4, liczba ta jest wpisywana rowniez do buz_num[n]
//-----------------------------------------------------------------------
		if(ulow[licz]<=uhigh[licz])						//jesli poczatek dnia jest liczba mniejsza niz koniec
				{if(anal[licz]>uhigh[licz]||anal[licz]<ulow[licz])//to dzien zawiera sie pomiedzy dzien_poczatey a dzien_koniec
					alarm[licz]=licz+1;
				else
					alarm[licz]=0;}

		if(ulow[licz]>uhigh[licz])				//jesli poczatek dnia jest liczba wieksza niz koniec
				{if(anal[licz]<ulow[licz]&&anal[licz]>uhigh[licz])
					alarm[licz]=licz+1;
				else alarm[licz]=0;
					}
//----------------------------------------------------------------------------

			}
//----------------------------------------------------------------------------
//Wyswietla zmierzone napiecia, wynik jest aktualizowany jesli lcd_time jest>250
//zapobiega to mruganiu cyfr przy szybkiej zmianie napiecia, jednaczesnie obsluga
//klawiatury jest natychmiastowa, jesli bylo wstawione opoznienie ok.100ms, w calej petli
// byly problemy z wykrywaniem nacisniecia klawisza
			if(lcd_time--==0)
				{lcd_time=30;
				lcd_gotoxy(1,1);
				lcd_putc("U1=");
				lcd_analog(anal[0]);
				lcd_putc("  U2=");
				lcd_analog(anal[1]);
				lcd_gotoxy(2,1);
				lcd_putc("U3=");
				lcd_analog(anal[2]);
				lcd_putc("  U4=");
				lcd_analog(anal[3]);
				while(get_key()>0);}
//--------------------------------------------------------------------------------------



	}
}
///////////////////////////KONIEC GWNEJ PTLI PROGRAMU MAIN//////////////////////////////


//************************************************************************//
//Wyswietla podana wartosc int16 w formacie xx.x       					  //
//************************************************************************//
lcd_analog(int16 analog_wejscie)
{
	get_dig(analog_wejscie);			//konwersja na piec cyfr
	lcd_putc(dig2);						//wyswietl cyfre 2
	lcd_putc(dig1);						//wyswietl cyfre 1
	lcd_putc('.');						//wyswietl przecinek
	lcd_putc(dig0);						//wyswietl cyfre 0
}
//************************************************************************//



//************************************************************************//
//Procedura odczytu klawiatury                                            //
//************************************************************************//
get_key()
{
byte key1;
key=portb|0b11110000;
if(key==0xff)
	{key=0;return(key);}
delay_ms(20);
key1=portb|0xf0;
if(key1!=key)
	{key=0;return(key);}
switch(key)
	{
	case 0b11111110:key=1;break;
	case 0b11111101:key=2;break;
	case 0b11111011:key=3;break;
	case 0b11110111:key=4;break;
	}

return(key);
}
//************************************************************************//
//*******************************************************************************************
//			Obsluga przerwania od T1
//*******************************************************************************************
#INT_TIMER1
void wave_timer()
{

byte time,num,al;
disable_interrupts(global);
bit_clear(pir1,tmr1if);						  //zeruj flage przerwania od t1
set_timer1(timer1_set);                       // sets timer to interrupt in 100ms

if(++time>20)
{time=0;num++;
if(num>3) num=0;
}

	if(alarm[num]==0) time=50;
	if(time<=alarm[num]*2)
		{if(bit_test(time,0))
	 		portb|=0xf0;		  //jesli alarm dla napiecia u1 to wlacz buzzer 1raz
	 	else portb&=0x0f;
	 	if(time==alarm[num]*2) time=10;
	 	}

	 else portb&=0x0f;

//---------------------------------------------------------------------------------


enable_interrupts(global);
}
////////////////////////////////////////////////////////////////////////////


//************************************************************************//
// Obsluga nastawianych parametrow napiecia                               //
//************************************************************************//
menu()
{	int16 analog_buf;
	byte k,key_buf;
	disable_interrupts(global);				//wylacza przerwania globalne
	portb&=0x0f;							//wylacza buzzer
	key_buf=key-1;							//zapisz numer klawisza do bufora
	lcd_putc("\rJe");
	lcd_putc(0);
	printf(lcd_putc,"li U%u>",key);
	lcd_analog(uhigh[key_buf]);
	lcd_putc('V');
	lcd_putc("\nJe");
	lcd_putc(0);
	printf(lcd_putc,"li U%u<",key);
	lcd_analog(ulow[key_buf]);
	lcd_putc('V');
	do{k=portb|0xf0;}while(k!=0xff);
	lcd_putc('\v');
	analog=uhigh[key_buf];
	do{
		lcd_gotoxy(1,13);
		get_key();
		if(key>0)
			{
				if(key==esc) goto menu_koniec;
				if(key==up)
					{analog++;
						if(analog>500) analog=0;
					}
				if(key==down)
					{
						analog--;
						if(analog==0xffff) analog=500;
					}
				lcd_gotoxy(1,10);
				lcd_analog(analog);
				lcd_putc('V');
				lcd_gotoxy(1,13);
			delay_ms(100);
			}
		}while(key!=ok);
	do{k=portb|0xf0;}while(k!=0xff);
	delay_ms(100);
	analog_buf=analog;
	analog=ulow[key_buf];
do{
		lcd_gotoxy(2,13);
		get_key();
		if(key>0)
			{
				if(key==esc) goto menu_koniec;
				if(key==up)
					{analog++;
						if(analog>500) analog=0;
					}
				if(key==down)
					{
						analog--;
						if(analog==0xffff) analog=500;
					}
				lcd_gotoxy(2,10);
				lcd_analog(analog);
				lcd_putc('V');
				lcd_gotoxy(2,13);
			delay_ms(100);
			}
		}while(key!=ok);
		uhigh[key_buf]=analog_buf;			//zapisz wartosc max do bufora uhigh
		ulow[key_buf]=analog;				//zapisz wartosc min do bufora ulow
		lcd_putc('\q');						//wylacza kursor
		lcd_putc("\r    Zapisane");
	delay_ms(1000);
menu_koniec:
	enable_interrupts(global);

}
//************************************************************************//