
////////////////////////////////////////////////////////////////////////////
//  Name    : UNTITLED.c                                               	  //
//  Author  : [Krzysztof Pawsiuk]                                        //
//  Notice  : Copyright (c) 2002 [AVT]                                    //
//  Compil. : CCS PCM C Compiler, Version 3.045, 12391                    //
//  Date    : 2002-12-06                                                  // 
//  Version : 1.0                                                         //
//  Notes   :                                                             //
//          :Procedury do transmisji pilota Sony                          // 
////////////////////////////////////////////////////////////////////////////
//	
//Dziala dobrze dla kwarcu 20Mhz, na 4MHz mniejszy zasieg
//
//


//#define led_ir gpio_1
//#define tris_led_ir trisio_1
//************************************************************************//
// inicjalizacja portu diody                                              //		
//************************************************************************//
#define sony_init() led_ir=0;\
		   tris_led_ir=0;	
//************************************************************************//

//************************************************************************//
//wysyla logicze zero f=40kHz,kwarc 20MHz                                 //		
//stan1 nadawanie przez 0,6ms											  //	
//dla f=40kHz cykl=25uS, dla 0,6ms trzeba powtorzyc 24razy                //
//************************************************************************//
sony_stan_0()
{int i;						//ustawienie parametrow poczatkowych 5cykli
	
	led_ir=0;				//zgas diode
	for(i=24;i>0;i--)		//powtorz 24razy	
		{led_ir=1;			//zapal diode
		 delay_us(12);		//zapal na 12us
		 delay_cycles(2);   //+400ns =12,4us
		 led_ir=0;			//zgas diode
		 delay_us(12);		//zgas na 12us +600ns=12,6us
		 }			
}
//************************************************************************//

//************************************************************************//
//wysyla logiczna jedynke f=40kHz,kwarc 20MHz                             //		
//stan1 nadawanie przez 1,2ms											  //	
//dla f=40kHz cykl=25uS, dla 1,2ms trzeba powtozyc 48razy                 //
//************************************************************************//
sony_stan_1()
{int i;
	led_ir=0;				//zgas diode
	for(i=48;i>0;i--)		//powtorz 48 razy
		{led_ir=1;			//zapal diode
		 delay_us(12);		//na 12us
		 delay_cycles(2);	//+400ns=12,4ns
		 led_ir=0;			//zgas diode
		 delay_us(12);		//na 12us+3cykle=12,6us 
		 }
}
//************************************************************************//
//************************************************************************//
//opozninienie pomiedzy bitami 	600us                                     //		
//************************************************************************//
sony_delay()
{
	led_ir=0;
	delay_us(599);
}
//************************************************************************//	

//************************************************************************//
// wysyla kod podany jako parametr 										  //	
//address-adres urzadzenia 0-63, command-komenda 0-127					  //	
//************************************************************************//
sony_send(int address, int command)
{ int ii;

	sony_stan_1();						//bit startu I \_2,4ms
	sony_stan_1();						//bit startu II/
	sony_delay();						//delay 0,6ms
	for(ii=0;ii<=6;ii++)				//wysyla 7 bitow command
		{
		command>>=1;
		if(bit_test(status,0)) sony_stan_1();
		else sony_stan_0();
		sony_delay();
		}
	
	for(ii=0;ii<=4;ii++)				//wysyla 5 bitow adresu
		{
		address>>=1;
		if(bit_test(status,0)) sony_stan_1();
		else sony_stan_0();
		sony_delay();
		}
}
//************************************************************************//